SystemOrganization addCategory: #'CT-RemoteBrowser-Core'!
SystemOrganization addCategory: #'CT-RemoteBrowser-Models'!
SystemOrganization addCategory: #'CT-RemoteBrowser-Monticello'!

OBCommand subclass: #CtCmdBrowseRemoteMethodVersions
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CT-RemoteBrowser-Core'!

!CtCmdBrowseRemoteMethodVersions methodsFor: 'accessing' stamp: 'mt 5/30/2009 18:25'!
buttonLabel

	^ 'versions (mc)'! !

!CtCmdBrowseRemoteMethodVersions methodsFor: 'execution' stamp: 'mt 5/19/2009 15:27'!
execute

	CtRemoteVersionBrowser openOn: target copy.! !

!CtCmdBrowseRemoteMethodVersions methodsFor: 'accessing' stamp: 'mt 5/30/2009 15:19'!
group

	^ #codetalk! !

!CtCmdBrowseRemoteMethodVersions methodsFor: 'accessing' stamp: 'mt 5/30/2009 15:18'!
icon

	^ #ctWorldIcon! !

!CtCmdBrowseRemoteMethodVersions methodsFor: 'accessing' stamp: 'mt 5/30/2009 15:18'!
iconOnly

	^ true! !

!CtCmdBrowseRemoteMethodVersions methodsFor: 'testing' stamp: 'mt 3/18/2010 19:01'!
isActive

	^ target notNil and: [target hasVersions and: [requestor isSelected: target]]! !

!CtCmdBrowseRemoteMethodVersions methodsFor: 'accessing' stamp: 'mt 5/30/2009 18:26'!
label

	^ 'browse monticello versions'! !

!CtCmdBrowseRemoteMethodVersions methodsFor: 'accessing' stamp: 'mt 5/27/2009 10:35'!
longDescription

  ^ 'display the different remote versions of this method - use repository of working copy'! !

!CtCmdBrowseRemoteMethodVersions methodsFor: 'testing' stamp: 'mt 5/18/2009 13:16'!
wantsButton

	^ true! !

OBCodeBrowser subclass: #CtRemoteVersionBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CT-RemoteBrowser-Core'!

!CtRemoteVersionBrowser class methodsFor: 'layout' stamp: 'mt 5/19/2009 10:21'!
maxPanes

	^ 1! !

!CtRemoteVersionBrowser class methodsFor: 'layout' stamp: 'mt 5/19/2009 10:21'!
minPanes

	^ 1! !

!CtRemoteVersionBrowser class methodsFor: 'instance creation' stamp: 'mt 5/25/2009 11:48'!
openOn: aMethodNode

	| instance version rootNode filter |
	version := OBMetaNode named: 'RemoteVersion'.	
	rootNode := OBMetaNode named: 'Method'.
	filter := CtReloadFilter new.
	
	version ancestrySelector: #isDescendantOfMethodVersion:.
	
	rootNode
		childAt: #remoteVersions put: version;
		addFilter: filter.

	instance := self metaNode: rootNode root: aMethodNode selection: nil.
	
	filter
		browser: instance;
		announcer: instance announcer;
		initializeForNode: aMethodNode.

	^ instance open! !

!CtRemoteVersionBrowser class methodsFor: 'layout' stamp: 'mt 5/26/2009 19:11'!
optionalButtons

	^ #('browse' 'revert')! !

!CtRemoteVersionBrowser class methodsFor: 'layout' stamp: 'mt 3/24/2010 09:20:53.662'!
panels

	^ {
		self optionalButtonPanel.
		self mercuryPanel.
		self navigationPanel.
		self progressPanel.
		self definitionPanel
	} reject: [:ea | ea isNil]! !

!CtRemoteVersionBrowser class methodsFor: 'layout' stamp: 'mt 5/26/2009 19:18'!
progressPanel

	^ CtProgressPanel new! !

!CtRemoteVersionBrowser methodsFor: 'building' stamp: 'mt 5/25/2009 10:13'!
defaultBackgroundColor

	^ Color gray muchLighter! !

!CtRemoteVersionBrowser methodsFor: 'accessing' stamp: 'mt 5/28/2009 10:04'!
defaultLabel

	^ 'Monticello Versions of {1}>>#{2}' format: {self root theClassName. self root selector}! !

!OBCodeBrowser methodsFor: '*ct-remotebrowser' stamp: 'mt 5/19/2009 15:19'!
cmdRemoteVersions
	^ CtCmdBrowseRemoteMethodVersions! !

SystemProgressBarMorph subclass: #CtPluggableProgressBarMorph
	instanceVariableNames: 'model maxSelector valueSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CT-RemoteBrowser-Core'!

!CtPluggableProgressBarMorph class methodsFor: 'as yet unclassified' stamp: 'mt 5/5/2009 20:53'!
newFor: aModel value: valSel max: maxSel

	^ self new
		model: aModel;
		maxSelector: maxSel;
		valueSelector: valSel! !

!CtPluggableProgressBarMorph methodsFor: 'accessing' stamp: 'mt 5/5/2009 20:45'!
maxSelector

	^ maxSelector! !

!CtPluggableProgressBarMorph methodsFor: 'accessing' stamp: 'mt 5/5/2009 20:45'!
maxSelector: aSymbol

	maxSelector := aSymbol! !

!CtPluggableProgressBarMorph methodsFor: 'accessing' stamp: 'mt 5/5/2009 20:42'!
model

	^ model! !

!CtPluggableProgressBarMorph methodsFor: 'accessing' stamp: 'mt 5/5/2009 20:43'!
model: anObject

	self model ifNotNilDo: [:m | m removeDependent: self].
	model := anObject.
	self model ifNotNilDo: [:m | m addDependent: self].! !

!CtPluggableProgressBarMorph methodsFor: 'updating' stamp: 'mt 5/5/2009 21:24'!
update: aSymbol

	super update: aSymbol.
	
	aSymbol = self valueSelector ifTrue: [self updateBar]! !

!CtPluggableProgressBarMorph methodsFor: 'updating' stamp: 'mt 5/5/2009 21:26'!
updateBar

	| value max |
	value := self model perform: self valueSelector.
	max := self model perform: self maxSelector.
	
	self 
		disableTableLayout: ((value = 0) | (value = max));
		visible: ((value = 0) | (value = max)) not.	
	
	self visible ifTrue:
		[self barSize: (value * self width) // max].! !

!CtPluggableProgressBarMorph methodsFor: 'accessing' stamp: 'mt 5/5/2009 20:45'!
valueSelector

	^ valueSelector! !

!CtPluggableProgressBarMorph methodsFor: 'accessing' stamp: 'mt 5/5/2009 20:54'!
valueSelector: aSymbol

	valueSelector := aSymbol.
	self update: aSymbol.! !

!OBMethodNode methodsFor: '*ct-remotebrowser' stamp: 'mt 5/2/2010 12:08:23.361'!
remoteVersions

	| result lastDate |
	self metaNode filters ifEmpty: [^ #()].
	
	result := OrderedCollection new.

	self metaNode filters first cache do: [:ver | |t|
		ver definition timeStamp ifNotEmpty: [
			t := ver definition fullTimeStamp.
			lastDate = t date ifFalse: [
				result add: (CtSeparatorNode text: t date printRelativeDate)].
			lastDate := t date.
			result add: (CtRemoteMethodVersionNode on: ver)]].

	^ result! !

OBFilter subclass: #CtReloadFilter
	instanceVariableNames: 'inspector cache announcer node isReloading browser updateProcess'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CT-RemoteBrowser-Models'!

!CtReloadFilter methodsFor: 'accessing' stamp: 'mt 5/25/2009 11:09'!
announcer

	^ announcer! !

!CtReloadFilter methodsFor: 'accessing' stamp: 'mt 5/25/2009 12:45'!
announcer: anObject

	announcer := anObject.! !

!CtReloadFilter methodsFor: 'accessing' stamp: 'mt 5/25/2009 11:48'!
browser

	^ browser! !

!CtReloadFilter methodsFor: 'accessing' stamp: 'mt 5/25/2009 11:48'!
browser: anObject

	browser := anObject.! !

!CtReloadFilter methodsFor: 'accessing' stamp: 'mt 5/25/2009 11:22'!
cache

	cache ifNil: [
		self cache: OrderedCollection new].
	^ cache! !

!CtReloadFilter methodsFor: 'accessing' stamp: 'mt 5/19/2009 16:45'!
cache: anObject

	cache := anObject.! !

!CtReloadFilter methodsFor: 'updating' stamp: 'mt 6/3/2009 09:51'!
doNodeRefreshing

	| sel |
	self browser navigationPanel currentColumn ifNotNilDo: [:col |
		sel := col selection].

	self announcer announce: OBRefreshRequired new.

	sel ifNotNilDo: [:s |
		self browser navigationPanel currentColumn selection: s].! !

!CtReloadFilter methodsFor: 'initalizing' stamp: 'rkrk 9/19/2009 22:58'!
initializeForNode: aMethodNode

	| reference definition |
	reference := aMethodNode reference.
	definition := aMethodNode definition.
	self inspector: (CtMczInspector newForPackageNamed: 
		(PackageOrganizer default packageOfMethod: reference) packageName).
		
	node := aMethodNode.
		
	self inspector
		addDependent: self;
		startInspectVersionsFor: definition selector
		in: definition theClass.! !

!CtReloadFilter methodsFor: 'accessing' stamp: 'mt 5/19/2009 16:47'!
inspector

	^ inspector! !

!CtReloadFilter methodsFor: 'accessing' stamp: 'mt 5/19/2009 16:45'!
inspector: anObject

	inspector := anObject.! !

!CtReloadFilter methodsFor: 'updating' stamp: 'mt 6/3/2009 09:51'!
refreshNodes

	updateProcess
		ifNil: [updateProcess := [
			self doNodeRefreshing.
			(Delay forMilliseconds: (
				self cache size < 3
					ifTrue: [1000]
					ifFalse: [3000])) wait.
			updateProcess := nil] fork].! !

!CtReloadFilter methodsFor: 'updating' stamp: 'mt 6/3/2009 09:51'!
update: aSymbol

	super update: aSymbol.
	aSymbol = #done ifTrue: [self refreshNodes].! !

!CtReloadFilter methodsFor: 'updating' stamp: 'rkrk 9/19/2009 19:33'!
update: aSymbol with: anObject

	super update: aSymbol with: anObject.
	
	aSymbol = #matchingVersionFound ifTrue: [
		self cache add: (CtRemoteMethodVersion
			repository: (anObject at: #repository)
			info: (anObject at: #info)
			definition: (anObject at: #definition)).
		self refreshNodes].! !

OBPanel subclass: #CtProgressPanel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CT-RemoteBrowser-Core'!

!CtProgressPanel methodsFor: 'as yet unclassified' stamp: 'mt 3/3/2010 15:36:51'!
buildOn: aBuilder

	| bar button row |
	bar := (CtPluggableProgressBarMorph
		newFor: self browser root metaNode filters first inspector
		value: #currentStep
		max: #maxSteps)
		hResizing: #spaceFill;
		vResizing: #spaceFill.
	button := CtButton
		on: self browser root metaNode filters first inspector
		action: #stop
		icon: #ctCrossIcon
		label: 'Stop'.
	row := Morph new
		changeTableLayout;
		hResizing: #spaceFill;
		vResizing: #shrinkWrap;
		listDirection: #leftToRight;
		addMorphBack: bar;
		addMorphBack: button;
		fillStyle: Color transparent.
		
	^ aBuilder insertMorph: row.! !

!CtProgressPanel methodsFor: 'as yet unclassified' stamp: 'mt 5/30/2009 18:34'!
vResizing

	^ #rigid! !

Object subclass: #CtMczCache
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CT-RemoteBrowser-Monticello'!

!CtMczCache class methodsFor: 'private' stamp: 'mt 5/15/2009 14:28'!
addMczToCache: aStream at: aMczFileName
	"Need to write a clean zip."
	
	^ ZipArchive new
		readFrom: aStream;
		writeToFileNamed: (self cacheDirectory fullNameFor: aMczFileName).! !

!CtMczCache class methodsFor: 'private' stamp: 'mt 5/15/2009 14:35'!
cacheAt: aFileName

	^ ZipArchive new
		readFrom: (self cacheDirectory readOnlyFileNamed: aFileName)! !

!CtMczCache class methodsFor: 'caching' stamp: 'mt 5/26/2009 18:48'!
cacheAt: aFileName ifNoneGetFrom: anHttpRepository
	"Return a zip archive for the mcz file."

	^ (self includes: aFileName)
		ifTrue: [self cacheAt: aFileName]
		ifFalse: [
			anHttpRepository
				readStreamForFileNamed: aFileName
				do: [:strm | self addMczToCache: strm at: aFileName]]! !

!CtMczCache class methodsFor: 'private' stamp: 'mt 5/15/2009 12:45'!
cacheDirectory

	^ (FileDirectory default directoryNamed: 'codetalk-cache')
		assureExistence;
		yourself! !

!CtMczCache class methodsFor: 'private' stamp: 'mt 5/15/2009 13:25'!
includes: aFileName

	^ self cacheDirectory includesKey: aFileName! !

Object subclass: #CtMczInspector
	instanceVariableNames: 'repositories isRunning process reader currentMethodDefinition followAncestors currentAncestors classFilter selectorFilter lastDefinition currentStep maxSteps'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CT-RemoteBrowser-Monticello'!

CtMczInspector class
	instanceVariableNames: 'exampleCache'!

CtMczInspector class
	instanceVariableNames: 'exampleCache'!

!CtMczInspector class methodsFor: 'examples' stamp: 'mt 5/19/2009 13:31'!
exampleVersions

	| instance result repo |
	exampleCache ifNotNilDo: [:c | ^ c].
	
	result := OrderedCollection new.
	instance := self newForPackageNamed: 'CodeTalk'.
	repo := instance repositories first key.
	(repo readableFileNames
		select: [:filename | filename startsWith: 'CodeTalk'])
		do: [:filename |
			instance zip: (CtMczCache
				cacheAt: filename
				ifNoneGetFrom: repo).
			instance loadVersionInfo.
			
			(instance zip memberNamed: 'snapshot.bin') ifNotNilDo: [:bin |
			[(DataStream on: bin contentStream) next definitions
				select: [:def | def isMethodDefinition and: [def className = 'CtLoader' and: [def selector = #todo]]]
				thenDo: [:def | result add: (CtRemoteMethodVersion
					repository: repo
					info: instance info
					definition: def)]]
				on: Error
				do: [:fallThrough | "Unknown content in snapshot.bin!!"]]] displayingProgress: 'Preparing...'.
	exampleCache := result.
	^ result! !

!CtMczInspector class methodsFor: 'instance creation' stamp: 'mt 3/24/2010 09:45:27.638'!
newForPackageNamed: aString

	| instance pkg repo |
	instance := self new.
	pkg := MCPackage named: aString.
	pkg hasWorkingCopy ifFalse: [^ instance].
	
	repo := OBChoiceRequest
		prompt: nil 
		labels: (pkg workingCopy repositoryGroup repositories collect: [:r | r description]) 
		values: pkg workingCopy repositoryGroup repositories.
	
	repo ifNotNil: [instance addRepository: repo include: {aString}].
	^ instance! !

!CtMczInspector class methodsFor: 'instance creation' stamp: 'rkrk 9/19/2009 23:51'!
newForPackagesNamed: packageNames inRepo: mcRepository

	| instance |
	instance := self new.
	instance
		addRepository: mcRepository
		include: packageNames.
	^ instance! !

!CtMczInspector methodsFor: 'adding repos' stamp: 'rkrk 9/19/2009 19:04'!
addRepository: anHttpRepository include: somePackageNames
	"Add the given repo and decide which packages
	to use when looking at the contents of the repo later."
	
	self repositories add: (anHttpRepository -> somePackageNames).! !

!CtMczInspector methodsFor: 'accessing' stamp: 'rkrk 9/19/2009 19:03'!
currentAncestors

	^ currentAncestors ifNil: [currentAncestors := Set new].! !

!CtMczInspector methodsFor: 'accessing status' stamp: 'rkrk 9/19/2009 19:04'!
currentStep

	^ currentStep ifNil: [currentStep := 1].! !

!CtMczInspector methodsFor: 'accessing status' stamp: 'mt 5/27/2009 10:03'!
currentStep: anObject

	currentStep := anObject.
	self changed: #currentStep.! !

!CtMczInspector methodsFor: 'inspecting' stamp: 'rkrk 9/19/2009 23:37'!
filterFileNames: someFileNames packages: somePackageNames

	| result fileNamesMatching |
	fileNamesMatching := someFileNames select: [:filename |
		somePackageNames anySatisfy: [:name |
			self packageName: name matchesFileName: filename]].
	result := fileNamesMatching sortBy: [:f1 :f2 |
		(f1 findTokens: $.) second asNumber > (f2 findTokens: $.) second asNumber].
	^ self followAncestors
		ifTrue: [result]
		ifFalse: [result reversed]! !

!CtMczInspector methodsFor: 'accessing' stamp: 'rkrk 9/19/2009 19:02'!
followAncestors

	^ followAncestors ifNil: [followAncestors := false].! !

!CtMczInspector methodsFor: 'accessing' stamp: 'mt 5/13/2009 14:13'!
followAncestors: anObject

	followAncestors := anObject.! !

!CtMczInspector methodsFor: 'inspecting - methods' stamp: 'rkrk 9/19/2009 22:53'!
inspectDefinitions

	| definition updateObject |
	definition := self reader definitions
		detect: [:def | def isMethodDefinition
			and: [classFilter = def actualClass]
			and: [selectorFilter = def selector]]
		ifNone: [^ self].
	lastDefinition = definition ifTrue: [^ self].
	updateObject := Dictionary newFrom: {
		#repository -> self reader repository.
		#definition -> definition.
		#info -> self reader info}.
	self changed: #matchingVersionFound with: updateObject.
	lastDefinition := definition.! !

!CtMczInspector methodsFor: 'inspecting' stamp: 'mt 5/2/2010 12:01:25.027'!
inspectRepository: anHttpRepository include: somePackageNames

	| filenames shouldInspectDefs |
	filenames := self
		filterFileNames: anHttpRepository readableFileNames
		packages: somePackageNames.
	self maxSteps: filenames size.		
	filenames withIndexDo: [:filename :i |	
		self currentStep: i.
		[
			self reader readFile: filename from: anHttpRepository.
			self inspectVersion.
			shouldInspectDefs := self followAncestors not
				or: [self currentAncestors isEmpty]
				or: [self currentAncestors anySatisfy: [:anc | anc name = self reader info name]].
			shouldInspectDefs ifTrue: [self inspectDefinitions].
			self followAncestors ifTrue: [self updateCurrentAncestry]
		] on: Error do: [:fallThrough |] ].! !

!CtMczInspector methodsFor: 'inspecting - methods' stamp: 'rkrk 9/19/2009 19:29'!
inspectSourceText: aText

	| result |
	result := aText attributesOfKind: XpfComplexAttribute.

	self changed: #resultFound with: (Dictionary newFrom: {
		#repository -> self reader repository.
		#definition -> currentMethodDefinition.
		#info -> self reader info.
		#attributes -> result}).! !

!CtMczInspector methodsFor: 'inspecting - versions' stamp: 'rkrk 9/19/2009 19:36'!
inspectVersion

	self changed: #versionFound with: self reader info.! !

!CtMczInspector methodsFor: 'accessing' stamp: 'mt 5/9/2009 12:03'!
isRunning

	isRunning ifNil: [self isRunning: false].
	^ isRunning! !

!CtMczInspector methodsFor: 'accessing' stamp: 'mt 5/9/2009 12:03'!
isRunning: anObject

	isRunning := anObject.
	self changed: #isRunning.! !

!CtMczInspector methodsFor: 'accessing status' stamp: 'rkrk 9/19/2009 19:04'!
maxSteps

	^ maxSteps ifNil: [maxSteps := 1].! !

!CtMczInspector methodsFor: 'accessing status' stamp: 'mt 5/27/2009 10:03'!
maxSteps: anObject

	maxSteps := anObject.
	self changed: #maxSteps.! !

!CtMczInspector methodsFor: 'testing' stamp: 'rkrk 9/19/2009 23:40'!
packageName: packageName matchesFileName: fileName

	"match only those packages which really include packageNames and not only start
	with that name.
	E.g. when somePackageNames = {CodeTalk} don't match CodeTalkExtension'"
	| packageNameDelimiter versionDelimiter followingChar |
	packageNameDelimiter := $-.
	versionDelimiter := $..
	(fileName beginsWith: packageName) ifFalse: [^ false].
	fileName size = packageName size ifTrue: [true].
	followingChar := fileName at: packageName size + 1.
	^ followingChar = packageNameDelimiter or: [followingChar = versionDelimiter].
! !

!CtMczInspector methodsFor: 'debugging' stamp: 'mt 5/26/2009 13:48'!
print

	Transcript show: ('Next Result: {1}>>{2} ({3}) - {4}' format: {
		currentMethodDefinition className.
		currentMethodDefinition selector.
		currentMethodDefinition category.
		self reader info name}); cr.! !

!CtMczInspector methodsFor: 'accessing' stamp: 'rkrk 9/19/2009 19:03'!
reader

	^ reader ifNil: [reader := CtMczReader new].! !

!CtMczInspector methodsFor: 'accessing' stamp: 'rkrk 9/19/2009 19:04'!
repositories

	^ repositories ifNil: [repositories := OrderedCollection new].! !

!CtMczInspector methodsFor: 'accessing' stamp: 'mt 5/9/2009 12:01'!
repositories: anObject

	repositories := anObject.! !

!CtMczInspector methodsFor: 'controlling' stamp: 'rkrk 9/19/2009 23:16'!
start

	process ifNotNil: [self stop].
	process := [
		[self isRunning: true.
		self repositories do: [:repo |
			self
				inspectRepository: repo key
				include: repo value.
			currentAncestors := nil].
		] ensure: [
			self
				isRunning: false;
				changed: #done]
	] fork priority: 20.! !

!CtMczInspector methodsFor: 'inspecting - versions' stamp: 'rkrk 9/19/2009 23:09'!
startInspectVersions

	self
		followAncestors: true;
		start.! !

!CtMczInspector methodsFor: 'inspecting - versions' stamp: 'rkrk 9/19/2009 23:09'!
startInspectVersionsFor: aSelector in: aClass

	classFilter := aClass.
	selectorFilter := aSelector.
	self startInspectVersions.! !

!CtMczInspector methodsFor: 'controlling' stamp: 'mt 5/9/2009 12:13'!
stop

	process ifNotNilDo: [:p | p terminate].
	process := nil.
	self isRunning: false.! !

!CtMczInspector methodsFor: 'inspecting' stamp: 'mt 6/3/2009 11:05'!
updateCurrentAncestry

	self reader info ancestors ifNotNilDo: [:newAnc |
		self currentAncestors addAll: newAnc].! !

Object subclass: #CtMczReader
	instanceVariableNames: 'zip info definitions repository'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CT-RemoteBrowser-Monticello'!

!CtMczReader commentStamp: 'mt 5/26/2009 13:09' prior: 0!
This is a simplified version of the McMczReader.!

!CtMczReader methodsFor: 'reading' stamp: 'topa 5/10/2010 18:58:58.717'!
associate: tokens

	| result |
	result := Dictionary new.
	tokens pairsDo: [:key :value | 
		| val |
		val := (value isString
			ifTrue: [value]
			ifFalse: [value collect: [:ea | self associate: ea]]).
		result at: key put: val].
	^ result! !

!CtMczReader methodsFor: 'accessing' stamp: 'mt 5/26/2009 13:09'!
definitions

	^ definitions! !

!CtMczReader methodsFor: 'accessing' stamp: 'mt 5/26/2009 13:09'!
definitions: anObject

	definitions := anObject.! !

!CtMczReader methodsFor: 'reading' stamp: 'mt 5/26/2009 13:11'!
extractInfoFrom: dict

	^ MCVersionInfo
		name: (dict at: #name ifAbsent: [''])
		id: (UUID fromString: (dict at: #id))
		message: (dict at: #message ifAbsent: [''])
		date: ([Date fromString: (dict at: #date) ] on: Error do: [ :ex | ex return: nil ])
		time: ([ Time fromString:(dict at: #time)] on: Error do: [ :ex | ex return: nil ])
		author: (dict at: #author ifAbsent: [''])
		ancestors: ((dict at: #ancestors ifAbsent: [#()]) collect: [:ea | self extractInfoFrom: ea])
		stepChildren: ((dict at: #stepChildren ifAbsent: [#()]) collect: [:ea | self extractInfoFrom: ea])! !

!CtMczReader methodsFor: 'public' stamp: 'mt 5/26/2009 13:58'!
getDefinitionByClass: aClass selector: aSelector

	^ self definitions
		detect: [:def |
			def actualClass = aClass
				and: [def selector = aSelector]]
		ifNone: []! !

!CtMczReader methodsFor: 'accessing' stamp: 'mt 5/26/2009 13:09'!
info

	^ info! !

!CtMczReader methodsFor: 'accessing' stamp: 'mt 5/26/2009 13:09'!
info: anObject

	info := anObject.! !

!CtMczReader methodsFor: 'reading' stamp: 'mt 5/26/2009 13:17'!
loadDefinitions

	(self zip memberNamed: 'snapshot.bin') ifNotNilDo: [:bin |
		[self	definitions:
			(DataStream on: bin contentStream) next definitions]
		on: Error
		do: [:fallThrough |
			self definitions: OrderedCollection new.
			Transcript show: 'Unknown content in snapshot.bin!!'; cr]].! !

!CtMczReader methodsFor: 'reading' stamp: 'mt 5/26/2009 13:11'!
loadVersionInfo

	info := self extractInfoFrom: (self parseMember: 'version')! !

!CtMczReader methodsFor: 'reading' stamp: 'mt 5/26/2009 13:12'!
parseMember: fileName

	| tokens |
	tokens := (MCScanner scanTokens: (zip contentsOf: fileName)) first.
	^ self associate: tokens! !

!CtMczReader methodsFor: 'public' stamp: 'mt 5/26/2009 13:32'!
readFile: aFilename from: aRepository

	self
		repository: aRepository;
		setZip: (CtMczCache cacheAt: aFilename ifNoneGetFrom: aRepository).! !

!CtMczReader methodsFor: 'accessing' stamp: 'mt 5/26/2009 13:32'!
repository

	^ repository! !

!CtMczReader methodsFor: 'accessing' stamp: 'mt 5/26/2009 13:32'!
repository: anObject

	repository := anObject.! !

!CtMczReader methodsFor: 'public' stamp: 'mt 5/26/2009 13:17'!
setZip: anMczFile

	self
		zip: anMczFile;
		loadVersionInfo;
		loadDefinitions.! !

!CtMczReader methodsFor: 'accessing' stamp: 'mt 5/26/2009 13:09'!
zip

	^ zip! !

!CtMczReader methodsFor: 'accessing' stamp: 'mt 5/26/2009 13:09'!
zip: anObject

	zip := anObject.! !

Object subclass: #CtRemoteMethodVersion
	instanceVariableNames: 'repository definition info'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CT-RemoteBrowser-Models'!

CtRemoteMethodVersion class
	instanceVariableNames: 'cache'!

CtRemoteMethodVersion class
	instanceVariableNames: 'cache'!

!CtRemoteMethodVersion class methodsFor: 'caching' stamp: 'mt 5/26/2009 14:06'!
cache

	cache ifNil: [self cache: 
		(LRUCache
			size: 100
			factory: [:key | | repo reader def |
				repo := MCHttpRepository
					location: key location
					user: key user
					password: key password.
				reader := CtMczReader new.
				reader readFile: key filename from: repo.
				def := reader getDefinitionByClass: key theClass selector: key selector.
				def ifNil: [Error signal].
				Transcript show: 'Factory used.'.
				CtRemoteMethodVersion
					repository: repo
					info: reader info
					definition: (reader getDefinitionByClass: key theClass selector: key selector)])].
	^ cache! !

!CtRemoteMethodVersion class methodsFor: 'caching' stamp: 'mt 5/26/2009 09:47'!
cache: anLRUCache

	cache :=  anLRUCache.! !

!CtRemoteMethodVersion class methodsFor: 'instance creation' stamp: 'mt 5/19/2009 11:38'!
repository: aRepository info: aVersionInfo definition: aMethodDefinition

	^ self new
		repository: aRepository;
		info: aVersionInfo;
		definition: aMethodDefinition! !

!CtRemoteMethodVersion methodsFor: 'accessing' stamp: 'mt 5/19/2009 16:22'!
= other

	^ self species = other species and: [self info timeStamp = other info timeStamp].! !

!CtRemoteMethodVersion methodsFor: 'accessing' stamp: 'mt 5/19/2009 11:28'!
category

	^ self definition category! !

!CtRemoteMethodVersion methodsFor: 'accessing' stamp: 'mt 5/19/2009 11:18'!
definition
	"This should be a Monticello method definition."

	^ definition! !

!CtRemoteMethodVersion methodsFor: 'accessing' stamp: 'mt 5/19/2009 11:17'!
definition: anObject

	definition := anObject.! !

!CtRemoteMethodVersion methodsFor: 'accessing' stamp: 'mt 5/19/2009 16:07'!
fileIn
	(self theClass) ifNotNilDo: [:class | class
						 				compile: self source 
										classified: self category 
										withStamp: self stamp 
										notifying: nil]! !

!CtRemoteMethodVersion methodsFor: 'accessing' stamp: 'mt 5/19/2009 11:18'!
info
	"This should be a Monticello version information object."

	^ info! !

!CtRemoteMethodVersion methodsFor: 'accessing' stamp: 'mt 5/19/2009 11:17'!
info: anObject

	info := anObject.! !

!CtRemoteMethodVersion methodsFor: 'accessing' stamp: 'mt 5/19/2009 11:17'!
repository

	^ repository! !

!CtRemoteMethodVersion methodsFor: 'accessing' stamp: 'mt 5/19/2009 11:17'!
repository: anObject

	repository := anObject.! !

!CtRemoteMethodVersion methodsFor: 'accessing' stamp: 'mt 5/19/2009 11:24'!
selector

	^ self definition selector! !

!CtRemoteMethodVersion methodsFor: 'accessing' stamp: 'mt 5/2/2010 11:14:16.469'!
source

	^ self definition source! !

!CtRemoteMethodVersion methodsFor: 'accessing' stamp: 'mt 5/25/2009 14:06'!
stamp

	^ self definition timeStamp! !

!CtRemoteMethodVersion methodsFor: 'accessing' stamp: 'mt 5/19/2009 11:24'!
theClass

	^ self definition actualClass! !

!CtRemoteMethodVersion methodsFor: 'accessing' stamp: 'mt 5/19/2009 15:38'!
theClassName

	^ self definition className! !

OBMethodVersionNode subclass: #CtRemoteMethodVersionNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CT-RemoteBrowser-Models'!

!CtRemoteMethodVersionNode class methodsFor: 'as yet unclassified' stamp: 'mt 5/19/2009 11:20'!
on: aRemoteMethodVersion

	^ self new setVersion: aRemoteMethodVersion! !

!CtRemoteMethodVersionNode methodsFor: 'as yet unclassified' stamp: 'mt 5/27/2009 16:02'!
name

	| author time ver|
	time := String streamContents: [:strm |
		self version definition fullTimeStamp time print24: true showSeconds: false on: strm].
	author := (self version stamp findTokens: Character space) first.
	ver := self version info name.
	
	^ '{1} {2} [{3}]' format: {time. author. ver}! !

!CtRemoteMethodVersionNode methodsFor: 'accessing' stamp: 'mt 5/19/2009 15:31'!
remoteVersion

	^ version! !

!CtRemoteMethodVersionNode methodsFor: 'accessing' stamp: 'mt 5/19/2009 15:31'!
remoteVersion: anObject

	version := anObject.! !

!CtRemoteMethodVersionNode methodsFor: 'as yet unclassified' stamp: 'mt 5/2/2010 11:20:00.044'!
selector

	^ self version selector! !

!CtRemoteMethodVersionNode methodsFor: 'as yet unclassified' stamp: 'mt 5/19/2009 11:28'!
source

	^ self sourceText! !

!CtRemoteMethodVersionNode methodsFor: 'as yet unclassified' stamp: 'mt 5/19/2009 15:35'!
theClass

	^ self version theClass! !

!CtRemoteMethodVersionNode methodsFor: 'as yet unclassified' stamp: 'mt 5/2/2010 11:20:18.173'!
timeStamp

	^ self version stamp! !

!CtRemoteMethodVersionNode methodsFor: 'as yet unclassified' stamp: 'mt 5/2/2010 11:20:55.352'!
version

	^ self remoteVersion! !
